#BEGIN COPYRIGHT
#*************************************************************************
#
# Licensed Materials - Property of IBM
# 5725-C94, 5725-C95, 5725-C96
# (C) Copyright IBM Corporation 2010, 2011. All Rights Reserved.
# US Government Users Restricted Rights- Use, duplication or disclosure
# restricted by GSA ADP Schedule Contract with IBM Corp.
#
#*************************************************************************
#END COPYRIGHT

from java.lang import System, String
import sys


print "*************************************************************************************"
print "start: init"
print ""

fileSeparator = System.getProperty("file.separator");
configUtilsScript = System.getProperty("was.install.root") + fileSeparator + "util" + fileSeparator + "config" + fileSeparator + "admin" + fileSeparator + "configUtils.py"
print "load configuration utils from ", configUtilsScript
execfile(configUtilsScript);

print ""
print "end: init"


def configureCustomSecurityProvider():
    global adminUserName, adminPassword;

    print ""
    BASE_ENTRY_NAME = "o=twinternal"

    try:
            # Create the twinternal custom repository
            REPO_NAME = "urbtwinternal"

            print "Creating the custom registry " + REPO_NAME
            AdminTask.createIdMgrCustomRepository('-id ' + REPO_NAME + ' -adapterClassName com.ibm.ws.wim.adapter.urbridge.URBridge')
            AdminTask.setIdMgrCustomProperty('-id '+ REPO_NAME + ' -name registryImplClass -value "com.ibm.bpm.security.provider.authentication.websphere.BPMInternalProviderImpl"')
            AdminTask.addIdMgrRepositoryBaseEntry('-id '+ REPO_NAME + ' -name '+BASE_ENTRY_NAME)
            print "Created the custom registry " + REPO_NAME
    except:
            # Ignore exception if we have already created the twinternal repo
            print "The custom registry ", REPO_NAME,  " cannot be created"

    print ""

    REALM_NAME = "defaultWIMFileBasedRealm"
    baseEntries = getObjectArray(AdminTask.listIdMgrRealmBaseEntries('-name '+ REALM_NAME))
    print "The value of baseEntries is ", baseEntries

    # A realm must have at least one base entry. Lets check if we have the Teamworks one
    # already added. If not, add it before we delete everyone else

    isBaseEntryExist = "false"
    for baseEntry in baseEntries:
            if (baseEntry == BASE_ENTRY_NAME):
                    isBaseEntryExist = "true"
                    break

    print "The value of isBaseEntryExist is ", isBaseEntryExist
    print ""

    if (isBaseEntryExist == "false"):
            print "Adding baseEntry " + BASE_ENTRY_NAME
            AdminTask.addIdMgrRealmBaseEntry('-name '+REALM_NAME+' -baseEntry '+BASE_ENTRY_NAME)

    print ""

    userRegistries = getObjectArray(AdminConfig.list("UserRegistry" ))
    print "The value of userRegistries is ", userRegistries

    m = re.compile("WIMUserRegistry")
    for userRegistry in userRegistries:
            if (m.search(userRegistry) ):
                    customRegistry = userRegistry
                    break
    print "The value of customRegistry is ", customRegistry
    print ""

    attrUser = ["serverId", adminUserName]
    attrPassword = ["serverPassword", adminPassword]
    attrPrimaryId = ["primaryAdminId", adminUserName]
    realm = ["realm", REALM_NAME]
    customRegistryAttributes = [attrUser, attrPassword, attrPrimaryId, realm]

    AdminConfig.modify(customRegistry, customRegistryAttributes )
    print "Modified the custom registry attributes"
    print ""

    attrUserReg = ["activeUserRegistry", customRegistry]

    globalSecurityAttributes = [attrUserReg]
    print "The value of globalSecurityAttributes is ", globalSecurityAttributes

    globalSecurity = AdminConfig.list("Security" )
    print "The value of globalSecurity is ", globalSecurity
    AdminConfig.modify(globalSecurity, globalSecurityAttributes )
    print "Modified the global security attributes"
    print ""

    fileRegistyDocument = "cells/" +  System.getProperty("local.cell") + "/fileRegistry.xml"
    print "The value of fileRegistyDocument is ", fileRegistyDocument

    if (AdminConfig.existsDocument(fileRegistyDocument)):
        print "deleting the fileRegistry.xml"
        AdminConfig.deleteDocument(fileRegistyDocument);
        print "deleted the fileRegistry.xml"
    else:
        print "The fileRegistry.xml does not exist"

    print ""

#endDef

def copyDatabaseSettings():
    global nodeName, serverName;

    print ""

    databaseSettingsDocument = "cells/" +  System.getProperty("local.cell") + "/nodes/" + nodeName + "/servers/" + serverName + "/process-center/config/system/98Database.xml"
    print "The value of fileRegistyDocument is ", databaseSettingsDocument

    if (AdminConfig.existsDocument(databaseSettingsDocument)):
            print "98Database.xml is found in a process-center environment"
    else:
            print "The 98Database.xml does not exist, searching for process-server..."
            databaseSettingsDocument = "cells/" +  System.getProperty("local.cell") + "/nodes/" + nodeName + "/servers/" + serverName + "/process-server/config/system/98Database.xml"
            if (AdminConfig.existsDocument(databaseSettingsDocument)):
                    print "98Database.xml is found in a process-server environment"
            else:
                    print "98Database.xml could not be found"
                    return 

    print "copying the 98Database.xml to the dmgr cell"
    databaseConfig = "cells/" + System.getProperty("local.cell") + "/98Database.xml"
    tempFile = System.getProperty("was.repository.temp") + "/98Database.xml"
    
    settingsObj = AdminConfig.extract(databaseSettingsDocument, tempFile)
    AdminConfig.createDocument(databaseConfig, tempFile)
    AdminConfig.checkin(databaseConfig, tempFile, settingsObj)

    os.remove(tempFile)
    
    print "copied the 98Database.xml to the dmgr cell"
    print ""

#endDef

def resetPassword():
    print "Reset password"
    from com.ibm.bpm.security.provider import BPMInternalSecurityProvider
    bpmSecurityProvider = BPMInternalSecurityProvider.getInstance()
    
    # verify if the user exist at the DB
    try:
        isUserExist = bpmSecurityProvider.userExist(adminUserName)
        if(isUserExist == 0):
            print "Do not need to reset the password for user: ", adminUserName
            return  
    except:
        print "Get exception when vefify if the user: ", adminUserName, " do not exist"
        return
        
    # reset the password    
    try:
        bpmSecurityProvider.resetCredential(adminUserName, adminPassword)
    except:
        print "Get exception when reset the password"    
#endDef

def getProfileAdmin():
    print "verify if the input user is the profile admin"
    
    userRegistries = getObjectArray(AdminConfig.list("UserRegistry" ))
    print "The value of userRegistries is ", userRegistries

    m = re.compile("WIMUserRegistry")
    for userRegistry in userRegistries:
            if (m.search(userRegistry) ):
                    customRegistry = userRegistry
                    break
    print "The value of customRegistry is ", customRegistry
    print ""
    
    primaryAdminId = AdminConfig.showAttribute(customRegistry, "primaryAdminId")
    
    return primaryAdminId
    
#endDef

def syncNodes():    
    print "Start sync nodes..."
    nodeAgentList = getObjectArray(AdminConfig.list("NodeAgent"))

    cellId = getObjectArray(AdminConfig.list("Cell"))

    nodeList = getObjectArray(AdminConfig.list('Node',cellId[0]))  
    nodenameList = []
    for node in nodeList:
        print node
        nodename = AdminConfig.showAttribute(node,'name')
        print nodename
        nodenameList.append(nodename)
    print nodenameList

    stoppedNodeList = []
    startedNodeList = []    
    
    for nodename in nodenameList:
        nodeAgentMbean = AdminControl.queryNames('type=NodeAgent,node=' + nodename + ',*')
        if(nodeAgentMbean == ""):
            # remove the dmgr node
            stoppedNodeList.append(nodename)
        else:
            startedNodeList.append(nodename)    

    for nodename in startedNodeList:
        try:
            nodeSyncId = AdminControl.completeObjectName('type=NodeSync,node=' + nodename + ',*')
            print "nodeSyncId=" + nodeSyncId
            AdminControl.invoke(nodeSyncId, 'sync')
            print "Sync node: " + nodename + " succeed."
        except:
            print "failed to sync node: " + nodename
    
    print "End sync nodes."
#endDef

def printUsage ():
    print ""
    print "Usage: wsadmin.[sh|bat] -conntype SOAP -user <user_name> -password <password> -f <target_install_root>/BPM/base/profile/actions/scripts/switchToCustomSecurityProvider.py -adminUserName <primary_user_name> -adminPassword <primary_password> -nodeName <node_name> -serverName <server_name>"
    print ""
    print "  -user, -password"
    print "    the primary user ID and password that are used for administrative security."
    print "  -adminUserName, -adminPassword"
    print "    the primary user ID and password that are used for administrative security."
    print "  -nodeName"
    print "    the name of any node where Process Server is configured." 
    print "  -serverName" 
    print "    the name of any server or cluster member on that node where Process Server is configured."   
    print "  The -nodeName and -serverName parameters are required for copying the 98Database.xml file from the given node and server to the deployment manager cell.                "
    sys.exit()
    
#endDef

#*******************************************************************************************************
# main
#*******************************************************************************************************
print "*************************************************************************************"
print "Start: Updating security configuration"
print ""

print "Begin to validate the input parameters"
print ""

error=0
adminUserName=""
adminPassword=""
nodeName=""
serverName=""
i = 0
try:
        while (i < len(sys.argv)):
            if (sys.argv[i] == "-adminUserName"):
                i+=1
                adminUserName = sys.argv[i]
            elif (sys.argv[i] == "-adminPassword"):
                i+=1
                adminPassword = sys.argv[i]
            elif (sys.argv[i] == "-nodeName"):
                i+=1
                nodeName = sys.argv[i]
            elif (sys.argv[i] == "-serverName"):
                i+=1
                serverName = sys.argv[i]
            else:
                print "ERROR: Encountered unrecognized command line parameter: %s" % sys.argv[i]
                error = 1
                i+=1
            #endElse
            i += 1
                #endWhile
except:
         print("Error!!!")
         printUsage()

if (error or not adminUserName or not adminPassword or not serverName or not nodeName):
        print "ERROR: Incorrect input parameters, please refer to the usage."
        printUsage()
#endIf


print "The value of adminUserName is " + adminUserName

print "The value of adminPassword is " + adminPassword

print "The value of nodeName is " + nodeName

print "The value of serverName is " + serverName

try:
        cellType = getCellType();
               
        if (isEmptyString(adminUserName) == "True"):
                adminUserName = "admin";
                print "The value of adminUserName is set to default ", adminUserName

        if (isEmptyString(adminPassword) == "True"):
                adminPassword = "admin";
                print "The value of adminPassword is set to default value"
                
        # check if the input admin user name is the profile admin        
        if(getProfileAdmin() != adminUserName):
            raise "The input admin user name is not correct"      

        if (cellType == "DISTRIBUTED"):
                print "Updating the security provider to custom on distributed (dmgr or customized) profile"
                # check whether the local node is a deployment manager Node
                isDMgrNode = isDMgrNode();

                if (isDMgrNode != "False"):
                        # verify the input password    
                        print "Verify the input password"      
                        pwCheckResult = AdminTask.WIMCheckPassword('-username ' + adminUserName + " -password " + adminPassword)
                        if(pwCheckResult != "true"):
                            raise "The input admin password is not correct"
                            
                        print "Updating the distributed dmgr profile"
                        configureCustomSecurityProvider();
                        copyDatabaseSettings();
                        AdminConfig.save();
                        syncNodes();
                        resetPassword();                  

                print ""
                print "*************************************************************************************"
                print "The custom security configuration is complete."
                print "*************************************************************************************"
                print ""

        else:
                print "The profile does not need an update."
except:
        print ""
        print "*************************************************************************************"
        print "The custom security configuration could not be created. The exception type is: ", sys.exc_type, ". The exception description is: ", sys.exc_value
        print "*************************************************************************************"
        print ""
        raise

print ""
print "End: Updating security configuration"
print "*************************************************************************************"

